package fr.username404.snowygui.gui.feature

import fr.username404.snowygui.ClickGui
import fr.username404.snowygui.gui.elements.ClickBox
import net.minecraft.network.chat.TranslatableComponent

/**
 * Should be used on classes/objects extending [ButtonImpl]
 */
@Target(AnnotationTarget.CLASS)
@Retention(AnnotationRetention.RUNTIME)
annotation class ButtonInfo(
    val parent: Category,
    val kind: Type = Type.TOGGLE
) {
    companion object {
        internal var lightningFactor: Float = 0.33F
        enum class Type {
            TOGGLE,
            CLICK
        }
    }
}; enum class Category(val translationKey: String, val categoryColor: Int) {
    MISC("snowy.clickbox.misc", Colors.BLUE),
    RISKY("snowy.clickbox.risky", Colors.RED),
    MACROS("snowy.clickbox.macros", Colors.GREEN);
    val box = ClickBox(
        x = 4.0 + (if (ordinal >= 1 && !riskyCheats) ordinal - 1 else ordinal) * 86, y = 4.0,
        name = TranslatableComponent(translationKey),
        color = categoryColor
    )
    constructor(translationKey: String, categoryColor: Colors): this(translationKey, categoryColor.hexValue)
    init {
        ClickGui.components.add(box)
    }
}

/**
 * Excludes a class from button collection
 */
annotation class Ignored